var TaoBaoWangWang = {
    _prefs: Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("extensions.tbww."),
    _process:Cc["@mozilla.org/process/util;1"].createInstance(Ci.nsIProcess),
    _observingOn: false,
    _timeoutID: null,
    _originalTab: null,
    _inited: false,

    onLoad: function() {
        this.register();  // preference register

        if (this._prefs.getBoolPref("urlbarHandler"))
            setTimeout(function() { TaoBaoWangWang.evalURLbar(true) }, 1000);

        var path;
        if (this._prefs.prefHasUserValue("exePath")) {
            this.initProcess(unescape(this._prefs.getCharPref("exePath")));
        } else {
            path = this.detectProcess();
            if (path && path != "NS_ERROR_FAILURE") {
                this._prefs.setCharPref("exePath", escape(path[0]));
                this.initProcess(path[0]);
            } else
                return;
        }
        gBrowser.addEventListener("DOMContentLoaded", this.onPageLoad, true);        
    },

    register: function() {
        this._prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
        this._prefs.addObserver("", this, false);
    },

    observe: function(aSubject, aTopic, aData) {
        if(aTopic != "nsPref:changed") return;
        switch (aData) {
            case "urlbarHandler":
              this.evalURLbar(this._prefs.getBoolPref("urlbarHandler"));
              break;
        }
    },

    onPageLoad: function(e) {
        var doc = e.originalTarget; // doc is document that triggered "onload" event 
        if(doc.location.href.search(".taobao.com/") > -1) {
            var ss = doc.styleSheets[0];
            if (ss)
                ss.insertRule('.tstart-minimized{ visibility:hidden}', ss.cssRules.length);
        }
    },

    detectProcess: function() {
        var wrk = Cc["@mozilla.org/windows-registry-key;1"].createInstance(Ci.nsIWindowsRegKey);
        var value;

        try {
            wrk.open(wrk.ROOT_KEY_CLASSES_ROOT, "aliim\\Shell\\Open\\Command", wrk.ACCESS_READ);
            value = wrk.readStringValue(null);
        } catch (e) {return e.name; }

        wrk.close();
        return value.match(/[a-zA-Z :\\]+wwcmd.exe/);
    },

    initProcess: function(path) {
        path = path.replace(/\\/g, "\\\\");

        var targetFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
        try {
            targetFile.initWithPath(path);
            this._process.init(targetFile);
        } catch(e){
            this._inited = false;           
            return e.name;
        }

        gBrowser.mPanelContainer.addEventListener('click', this.handleEvent, true);
        this._inited = true;
    },

    evalURLbar: function(aBool) {
        var urlbar = document.getElementById("urlbar");
        if (!urlbar) return;
        if (aBool)
            eval("urlbar.handleCommand = " + urlbar.handleCommand.toString().replace(
                'urlbar.value = url;',
                'urlbar.value = url; if (TaoBaoWangWang.urlbarHandler(url, aTriggeringEvent)) return;'
            ));
        else
            eval("urlbar.handleCommand = " + urlbar.handleCommand.toString().replace(
                'if (TaoBaoWangWang.urlbarHandler(url, aTriggeringEvent))',
                'if (false)'
            ));
    },

    urlbarHandler: function(url, e) {
        if (!TaoBaoWangWang._inited) return false;
        var i = 0;
        for each (let linkHead in TaoBaoWangWang._localLinks) {
            if (url.substr(0, linkHead.length) == linkHead) {
                if (url == "#")
                    return false;
                e.preventDefault();
                e.stopPropagation();
                this.launchIM1(url, i, e);
                return true;
            }
            i++;
        }
        return false;
    },

    handleEvent: function(e) {
        if (e.button != 0) return;

        var target = e.target;
        TaoBaoWangWang._originalTab = gBrowser.selectedTab;

        if (e.originalTarget.localName == "object") {   //flash
            TaoBaoWangWang.startHTTPObserver();
            if (TaoBaoWangWang._timeoutID)
                window.clearTimeout(TaoBaoWangWang._timeoutID);
            TaoBaoWangWang._timeoutID = setTimeout(function() { TaoBaoWangWang.stopHTTPObserver() }, 5000);
            return;
        }

        var linkNode;
        if (target instanceof HTMLAnchorElement ||
            target instanceof HTMLAreaElement ||
            target instanceof HTMLLinkElement) {
            if (target.hasAttribute("href"))
                linkNode = target;

            var parent = target.parentNode;
            while (parent && !linkNode) {
                if (parent instanceof HTMLAnchorElement ||
                    parent instanceof HTMLAreaElement ||
                    parent instanceof HTMLLinkElement) {
                    if (parent.hasAttribute("href"))
                        linkNode = parent;
                }
                parent = parent.parentNode;
            }
        } else {
            linkNode = e.originalTarget;
            while (linkNode && !(linkNode instanceof HTMLAnchorElement))
                linkNode = linkNode.parentNode;
            if (linkNode && !linkNode.hasAttribute("href"))
                linkNode = null;
        }

        if (linkNode) {
            var url = linkNode.getAttribute("href");
            TaoBaoWangWang.handleLink(url, e);
        }
    },

    handleLink: function(url, e) {
        var i = 0;
        for each (let linkHead in TaoBaoWangWang._localLinks) {
            if (url.substr(0, linkHead.length) == linkHead) {
                if (url == "#" && !e.originalTarget.hasAttribute("onmousedown") &&
                                  !e.originalTarget.hasAttribute("alitalk")
                   )
                    return;
                TaoBaoWangWang.launchIM1(url, i, e);
                return;
            }
            i++;
        }
    },

    _localLinks: ["http://www.taobao.com/webww/?"           //taobao - search AND detail/header
                 ,"http://amos.im.alisoft.com/getcid.aw?"   //taobao - detail/left1
                 ,"http://amos1.taobao.com/msg.ww?"         //taobao - detail/left2
                 ,"http://www.taobao.com/webww/ww.php?"     //taobao - detail/left3
                 ,"http://amos.im.alisoft.com/msg.aw?"      //taobao - detail/top1
                 ,"http://webwwtb.im.alisoft.com/wangwang/ww1.htm?"      //taobao - selled out list
                 ,"http://www.taobao.com/webww/index.php?"  //taobao - detail/left4  http://xcjy.tmall.com/shop/viewShop.htm
                 ,"http://tbamos.alicdn.com/msg.ww?"        //taobao - detail/left5  http://item.taobao.com/item.htm?id=7095565758  http://fcsj.taobao.com/
                 ,"#"                                       //alibaba - search
                 ,"#"                                       //alibaba - left/bottom
                 ],
    _localLinks2: ["=cntaobao[^&=-]+"
                  ,"&uid=[^&=]*"
                  ,"&uid=[^&=]*"
                  ,"&touid=[^&=]*"
                  ,"&uid=[^&=]*"
                  ,"&tid=[^&=]*"
                  ,"&touid=[^&=]*"
                  ,"&uid=[^&=]*"
                  ,"\{toId:'[^']+"
                  ,"\{id:'[^']+"
                  ],
    _localLinks3: ["&gid=[^&=]+"
                  ,""
                  ,""
                  ,""
                  ,""
                  ,"\\?t=[^&=]+"
                  ,""
                  ,""
                  ,",offerId:'[^']*"
                  ,""
                  ],

    launchIM1: function(url, index, e) {
    try {        
        var id;
        switch (index) {
            case 0:
                id = url.match(new RegExp(this._localLinks2[index]));
                if (id) id = id[0].substr(9);
                break;
            case 1:
                id = url.match(new RegExp(this._localLinks2[index]));
                if (id) id = id[0].substr(5);
                if (id) id = unescape(id);
                break;
            case 2:
                id = url.match(new RegExp(this._localLinks2[index]));
                if (id) id = id[0].substr(5);
                break;
            case 3:
                id = url.match(new RegExp(this._localLinks2[index]));
                if (id) id = id[0].substr(7);
                break;
            case 4:
                id = url.match(new RegExp(this._localLinks2[index]));
                if (id) id = id[0].substr(5);
                if (id) id = unescape(encodeURI(id));
                break;
            case 5:
                id = url.match(new RegExp(this._localLinks2[index]));
                if (id) id = id[0].substr(5);
                if (id) id = encodeURI(unescape(id));
                break;
            case 6:
                id = url.match(new RegExp(this._localLinks2[index]));
                if (id) id = id[0].substr(7);
                break;
            case 7:
                id = url.match(new RegExp(this._localLinks2[index]));
                if (id) id = id[0].substr(5);
                break;
            case 8:     //alibaba
                url = null;
                if (e.originalTarget.hasAttribute("onmousedown"))
                    url = e.originalTarget.getAttribute("onmousedown");
                if (url)
                    id = url.match(new RegExp(this._localLinks2[index]));
                if (id) id = id[0].substr(7);

                if (id) 
                    break;
                else
                    index = 9;
            case 9:     //alibaba
                url = null;
                if (e.originalTarget.hasAttribute("alitalk"))
                    url = e.originalTarget.getAttribute("alitalk");
                if (url)
                    id = url.match(new RegExp(this._localLinks2[index]));
                if (id) id = id[0].substr(5);
                break;
            default:
                break;
        }

        if (!id) return;

        var oURL;
        var gid = url.match(new RegExp(this._localLinks3[index], "i"));
        switch (index) {
            case 0:
                oURL = "aliim:sendmsg?touid=cntaobao" + id;
                if (gid) oURL = oURL + gid[0];
                oURL = oURL + "&siteid=cntaobao"
                break;
            case 1:
            case 2:
            case 3:
            case 4:
            case 6:
            case 7:
                oURL = "aliim:sendmsg?touid=cntaobao" + id + "&siteid=cntaobao";
                break;
            case 5:
                oURL = "aliim:sendmsg?touid=cntaobao" + id;
                if (gid) oURL = oURL + "&gid=" + gid[0].substr(3);
                oURL = oURL + "&siteid=cntaobao"
                break;
            case 8:
                var oURL = "aliim:sendmsg?touid=cnalichn" + id + "&gid=" + gid[0].substr(10) + "&siteid=cnalichn"
                break;
            case 9:
                var oURL = "aliim:sendmsg?touid=cnalichn" + id + "&siteid=cnalichn"
                break;
            default:
                break;
        }

        e.preventDefault();
        e.stopPropagation();
        var arguments = [oURL];
        this._process.run(false, arguments, arguments.length, {});

    } catch (e) {}
    },

    startHTTPObserver: function() {
        if (!this._observingOn) {
            var s = Cc['@mozilla.org/observer-service;1'].getService(Ci.nsIObserverService);
            s.addObserver(this.observer, 'http-on-modify-request', false);
            this._observingOn = true;
        }
    },

    stopHTTPObserver: function() {
        if (this._observingOn) {
            var s = Cc['@mozilla.org/observer-service;1'].getService(Ci.nsIObserverService);
            s.removeObserver(TaoBaoWangWang.observer, 'http-on-modify-request', false);
            TaoBaoWangWang._observingOn = false;
        }
    },

    observer: {
        observe: function(aSubject, aTopic, aData) {
            aSubject.QueryInterface(Ci.nsIHttpChannel);
            var url = aSubject.URI.spec;

            var i = 0;
            for each (let linkHead in TaoBaoWangWang._tbRequests) {
                if (url.substr(0, linkHead.length) == linkHead) {
                    aSubject.cancel(Components.results.NS_ERROR_FAILURE);
                    TaoBaoWangWang.launchIM2(url, i);

                    setTimeout(function(aSubject){TaoBaoWangWang.observer.closeBlankDOM(aSubject);}, 500);
                    setTimeout(function(aSubject){TaoBaoWangWang.observer.closeBlankDOM(aSubject);}, 3000);
                    setTimeout(function(aSubject){TaoBaoWangWang.observer.closeBlankDOM(aSubject);}, 6000);
                    return;
                }
                i++;
            }
        },

        closeBlankDOM: function(aSubject) {
            //for tab
            var oldTab = TaoBaoWangWang._originalTab;
            for(var i = gBrowser.mTabs.length - 1; i >= 0; i--) {
                var t = gBrowser.mTabs[i];
                if (t == oldTab) break;
                if (gBrowser.browsers[i].currentURI.spec == 'about:blank' && !t.getAttribute("busy")) {
                    gBrowser.selectedTab = oldTab;
                    gBrowser.removeTab(t);
                }
            }

            //for window
            var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
            var enumerator = wm.getEnumerator("navigator:browser");
            while(enumerator.hasMoreElements()) {
                var win = enumerator.getNext();
                var g = win.gBrowser;
                if (g.browsers.length == 1 && g.browsers[0].currentURI.spec == 'about:blank' && !g.mTabs[0].getAttribute("busy"))
                    win.close();
            }  
        },
    },

    _tbRequests: ["http://amos.im.alisoft.com/msg.aw?"     //flash
                 ,"http://amos1.taobao.com/msg.aw?"        //flash
                 ],

    _tbRequests2: ["&uid=[^&=]+"
                  ,"&uid=[^&=]+"
                  ],

    _tbRequests3: ["&gid=[^&=]+"
                  ,"&gid=[^&=]+"
                  ],

    launchIM2: function(url, index) {
    try {
            var id = url.match(new RegExp(this._tbRequests2[index], "i"));
            switch (index) {
                case 0:
                case 1:
                    if (id) id = id[0].substr(5);
                    break;
                default:
                    break;
            }

            if (!id) return;

            var oURL;
            var gid = url.match(new RegExp(this._tbRequests3[index], "i"));
            switch (index) {
                case 0:
                case 1:
                    oURL = "aliim:sendmsg?touid=cntaobao" + id;
                    if (gid) oURL = oURL + gid[0];
                    oURL = oURL + "&siteid=cntaobao"
                    break;
                default:
                    break;
            }

            var arguments = [oURL];
            this._process.run(false, arguments, arguments.length, {});

        } catch (e) {}
    },

} //var end

window.addEventListener("load", function(e) { TaoBaoWangWang.onLoad(); }, false);
